/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Krb5.xs. Do not edit this file, edit Krb5.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Krb5.xs"
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <krb5.h>
#include <et/com_err.h>
#include <errno.h>
#include "krb5_constants.c"

#ifdef __cplusplus
}
#endif

/* change this if 10 hours doesn't suit you */
#define KRB5_DEFAULT_LIFE 60*60*10

typedef krb5_ccache		Authen__Krb5__Ccache;
typedef krb5_principal		Authen__Krb5__Principal;
typedef krb5_auth_context	Authen__Krb5__AuthContext;
typedef krb5_rcache		Authen__Krb5__Rcache;
typedef krb5_creds		*Authen__Krb5__Creds;
typedef krb5_ap_rep_enc_part	*Authen__Krb5__ApRepEncPart;
typedef krb5_ticket		*Authen__Krb5__Ticket;
typedef krb5_keytab		Authen__Krb5__Keytab;
typedef krb5_enc_tkt_part	*Authen__Krb5__EncTktPart;
typedef krb5_error		*Authen__Krb5__Error;
typedef krb5_address		*Authen__Krb5__Address;
typedef krb5_keyblock		*Authen__Krb5__Keyblock;
typedef krb5_keytab_entry	*Authen__Krb5__KeytabEntry;
typedef krb5_kt_cursor          *Authen__Krb5__KeytabCursor;
typedef krb5_cc_cursor          *Authen__Krb5__CcacheCursor;
typedef krb5_keyblock		*Authen__Krb5__KeyBlock;

static krb5_context context = NULL;
static krb5_error_code err;
static krb5_keytab_entry keytab_entry_init;

/*
 * The following three routines implement a "safehouse" for nested Kerberos
 * data structures which shouldn't be freed before their parent data
 * structures are freed.  Without this, "Bad free() ignored" errors as well
 * as core dumps could occur when the parent structures are eventually freed.
 *
 * If a method returns a newly allocated object, it calls can_free() to
 * register the object as "freeable," since the memory was not in use
 * beforehand.  This module will only free objects that have been registered
 * with can_free(), and lets Kerberos free the others.
 *
 * Doing it the other way (registering objects which *shouldn't* be freed)
 * is more complicated than it first seems, so I did it this way.
 */


HV *free_hash = NULL; /* might as well take advantage of Perl! */

void can_free(SV *sv)
{
	char key[80];

	sprintf(key,"%p",sv);
	if (!free_hash) free_hash = newHV();
	hv_store(free_hash,key,strlen(key),&PL_sv_yes,0);
}

int should_free(SV *sv)
{
	char key[80];

	if (!free_hash) return 0;
	sprintf(key,"%p",sv);
	return hv_exists(free_hash,key,strlen(key));
}

void freed(SV *sv)
{
	char key[80];

	if (!free_hash) return;
	sprintf(key,"%p",sv);
	hv_delete(free_hash,key,strlen(key),G_DISCARD);
}


#line 96 "Krb5.c"

XS(XS_Authen__Krb5_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_constant)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::constant(name, arg)");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	int	arg = (int)SvIV(ST(1));
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_error)
{
    dXSARGS;
    if (items < 0 || items > 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::error(e = 0)");
    {
	krb5_error_code	e;

	if (items < 1)
	    e = 0;
	else {
	    e = (int)SvIV(ST(0));
	}
#line 98 "Krb5.xs"
	if (e) {
		ST(0) = sv_2mortal(newSVpv((char *)error_message(e), 0));
	}
	else {
		ST(0) = sv_2mortal(newSVpv((char *)error_message(err), 0));
		SvUPGRADE(ST(0), SVt_PVIV);
		SvIVX(ST(0)) = err;
		SvIOK_on(ST(0));
	}
#line 141 "Krb5.c"
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_init_context); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_init_context)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::init_context()");
    {
#line 112 "Krb5.xs"
	if (context) croak("Authen::Krb5 already initialized");
	err = krb5_init_context(&context);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 159 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5_free_context); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_free_context)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::free_context()");
    {
#line 121 "Krb5.xs"
	if (!context) croak("Authen::Krb5 not yet initialized");
	krb5_free_context(context);
        context = NULL;
#line 176 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5_init_ets); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_init_ets)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::init_ets()");
    {
#line 129 "Krb5.xs"
#if KRB5_DEPRECATED
	krb5_init_ets(context);
#endif /* KRB5_DEPRECATED */
	XSRETURN_YES;
#line 194 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5_get_default_realm); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_get_default_realm)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::get_default_realm()");
   PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 138 "Krb5.xs"
	char *realm;

#line 212 "Krb5.c"
#line 141 "Krb5.xs"
	err = krb5_get_default_realm(context,&realm);
	if (err || !realm) XSRETURN_UNDEF;
	XPUSHs(sv_2mortal(newSVpv(realm,strlen(realm))));
	Safefree(realm);
#line 218 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5_get_host_realm); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_get_host_realm)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::get_host_realm(host)");
    SP -= items;
    {
	char *	host = (char *)SvPV_nolen(ST(0));
#line 151 "Krb5.xs"
	char **realmlist;
	int i;

#line 238 "Krb5.c"
#line 155 "Krb5.xs"
	err = krb5_get_host_realm(context,host,&realmlist);
	if (err || !realmlist) XSRETURN_UNDEF;
	for (i = 0; realmlist[i]; i++) {
		XPUSHs(sv_2mortal(newSVpv(realmlist[i],
			strlen(realmlist[i]))));
	}
	krb5_free_host_realm(context,realmlist);
#line 247 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5_get_krbhst); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_get_krbhst)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::get_krbhst(realm)");
    SP -= items;
    {
	char *	realm = (char *)SvPV_nolen(ST(0));
#line 168 "Krb5.xs"
	krb5_data realm_data;
	char **hostlist;
	int i;

#line 268 "Krb5.c"
#line 173 "Krb5.xs"
	realm_data.data = realm;
	realm_data.length = strlen(realm);
	err = krb5_get_krbhst(context,&realm_data,&hostlist);
	if (err || !hostlist) XSRETURN_UNDEF;
	for (i = 0; hostlist[i]; i++) {
		XPUSHs(sv_2mortal(newSVpv(hostlist[i],
			strlen(hostlist[i]))));
	}
	krb5_free_krbhst(context,hostlist);
#line 279 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5_build_principal_ext); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_build_principal_ext)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::build_principal_ext(p)");
    {
	Authen__Krb5__Principal	p;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	};
#line 188 "Krb5.xs"
	err = krb5_build_principal_ext(context, &RETVAL,
		krb5_princ_realm(context, p)->length,
		krb5_princ_realm(context, p)->data,
		KRB5_TGS_NAME_SIZE, KRB5_TGS_NAME,
		krb5_princ_realm(context, p)->length,
		krb5_princ_realm(context, p)->data,
		0);

	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 319 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Principal", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_parse_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_parse_name)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::parse_name(name)");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	Authen__Krb5__Principal	RETVAL;
#line 208 "Krb5.xs"
	err = krb5_parse_name(context,name,&RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 342 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Principal", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_sname_to_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_sname_to_principal)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::sname_to_principal(hostname, sname, type)");
    {
	char *	hostname = (char *)SvPV_nolen(ST(0));
	char *	sname = (char *)SvPV_nolen(ST(1));
	krb5_int32	type = (int)SvIV(ST(2));
	Authen__Krb5__Principal	RETVAL;
#line 223 "Krb5.xs"
	err = krb5_sname_to_principal(context,hostname,sname,type,&RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 367 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Principal", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_cc_resolve); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_cc_resolve)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::cc_resolve(string_name)");
    {
	char *	string_name = (char *)SvPV_nolen(ST(0));
	Authen__Krb5__Ccache	RETVAL;
#line 236 "Krb5.xs"
	err = krb5_cc_resolve(context, string_name, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 390 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Ccache", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_cc_default_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_cc_default_name)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::cc_default_name()");
    {
	char *	RETVAL;
	dXSTARG;
#line 248 "Krb5.xs"
	RETVAL = (char *)krb5_cc_default_name(context);

#line 410 "Krb5.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_cc_default); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_cc_default)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::cc_default()");
    {
	Authen__Krb5__Ccache	RETVAL;
#line 257 "Krb5.xs"
	err = krb5_cc_default(context, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 431 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Ccache", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_kt_resolve); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_kt_resolve)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::kt_resolve(string_name)");
    {
	char *	string_name = (char *)SvPV_nolen(ST(0));
	Authen__Krb5__Keytab	RETVAL;
#line 270 "Krb5.xs"
	err = krb5_kt_resolve(context, string_name, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 454 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Keytab", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_kt_default_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_kt_default_name)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::kt_default_name()");
    {
	char *	RETVAL;
	dXSTARG;
#line 281 "Krb5.xs"
        char name[BUFSIZ];
        err = krb5_kt_default_name(context, name, sizeof name - 1);
	if (err)
                XSRETURN_UNDEF;
        name[sizeof name - 1] = '\0';
	ST(0) = sv_2mortal(newSVpv(name, 0));
#line 478 "Krb5.c"
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_kt_default); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_kt_default)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::kt_default()");
    {
	Authen__Krb5__Keytab	RETVAL;
#line 291 "Krb5.xs"
        err = krb5_kt_default(context, &RETVAL);
	if (err)
                XSRETURN_UNDEF;

#line 497 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Keytab", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_kt_read_service_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_kt_read_service_key)
{
    dXSARGS;
    if (items < 2 || items > 4)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::kt_read_service_key(name, principal, kvno = 0, enctype = 0)");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	Authen__Krb5__Principal	principal;
	krb5_kvno	kvno;
	krb5_enctype	enctype;
	Authen__Krb5__Keyblock	RETVAL;

	if (ST(1) == &PL_sv_undef) {
		principal = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		principal = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("principal is not of type Authen::Krb5::Principal");
	};

	if (items < 3)
	    kvno = 0;
	else {
	    kvno = (unsigned int)SvUV(ST(2));
	}

	if (items < 4)
	    enctype = 0;
	else {
	    enctype = (int)SvIV(ST(3));
	}
#line 306 "Krb5.xs"
        err = krb5_kt_read_service_key(context, name, principal, kvno, enctype,
            &RETVAL);
        if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 547 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Keyblock", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_get_init_creds_password); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_get_init_creds_password)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::get_init_creds_password(client, password, service = NULL)");
    {
	Authen__Krb5__Principal	client;
	char *	password = (char *)SvPV_nolen(ST(1));
	char *	service;
#line 322 "Krb5.xs"
	krb5_get_init_creds_opt opt;

#line 568 "Krb5.c"
	Authen__Krb5__Creds	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	};

	if (items < 3)
	    service = NULL;
	else {
	    service = (char *)SvPV_nolen(ST(2));
	}
#line 325 "Krb5.xs"
	if (service != NULL && service[0] == '\0') service = NULL;
	RETVAL = calloc(1, sizeof(krb5_creds));
	if (RETVAL == NULL) {
		err = errno;
		XSRETURN_UNDEF;
	}
	krb5_get_init_creds_opt_init(&opt);

	err = krb5_get_init_creds_password(context, RETVAL, client, password,
		NULL, NULL, 0, service, &opt);
	if (err) {
		free(RETVAL);
		XSRETURN_UNDEF;
	}
	can_free((SV *)RETVAL);

#line 604 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Creds", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_get_init_creds_keytab); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_get_init_creds_keytab)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::get_init_creds_keytab(client, keytab, service = NULL)");
    {
	Authen__Krb5__Principal	client;
	Authen__Krb5__Keytab	keytab;
	char *	service;
#line 351 "Krb5.xs"
	krb5_get_init_creds_opt opt;

#line 625 "Krb5.c"
	Authen__Krb5__Creds	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	};

	if (ST(1) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};

	if (items < 3)
	    service = NULL;
	else {
	    service = (char *)SvPV_nolen(ST(2));
	}
#line 354 "Krb5.xs"
	if (service != NULL && service[0] == '\0') service = NULL;
	RETVAL = calloc(1, sizeof(krb5_creds));
	if (RETVAL == NULL) {
		err = errno;
		XSRETURN_UNDEF;
	}
	krb5_get_init_creds_opt_init(&opt);

	err = krb5_get_init_creds_keytab(context, RETVAL, client, keytab, 0,
		service, &opt);
	if (err) {
		free(RETVAL);
		XSRETURN_UNDEF;
	}
	can_free((SV *)RETVAL);

#line 672 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Creds", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_get_in_tkt_with_password); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_get_in_tkt_with_password)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::get_in_tkt_with_password(client, server, password, cc)");
    {
	Authen__Krb5__Principal	client;
	Authen__Krb5__Principal	server;
	char *	password = (char *)SvPV_nolen(ST(2));
	Authen__Krb5__Ccache	cc;
#line 385 "Krb5.xs"
	krb5_creds cr;
	krb5_get_init_creds_opt opt;
	char *service;

#line 696 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	};

	if (ST(1) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	};

	if (ST(3) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 390 "Krb5.xs"
	memset((char *)&cr,0,sizeof(krb5_creds));
	krb5_get_init_creds_opt_init(&opt);
	err = krb5_unparse_name(context, server, &service);
	if (err) XSRETURN_UNDEF;

	err = krb5_get_in_tkt_with_password(context, &cr, client, password,
		NULL, NULL, 0, service, &opt);
	free(service);
	if (err) XSRETURN_UNDEF;

	err = krb5_cc_initialize(context, cc, client);
	if (err) {
		krb5_free_cred_contents(context, &cr);
		XSRETURN_UNDEF;
	}
	err = krb5_cc_store_cred(context, cc, &cr);
	if (err) {
		krb5_free_cred_contents(context, &cr);
		XSRETURN_UNDEF;
	}
	krb5_free_cred_contents(context, &cr);

	XSRETURN_YES;
#line 754 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5_get_in_tkt_with_keytab); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_get_in_tkt_with_keytab)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::get_in_tkt_with_keytab(client, server, keytab, cc)");
    {
	Authen__Krb5__Principal	client;
	Authen__Krb5__Principal	server;
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__Ccache	cc;
#line 422 "Krb5.xs"
	krb5_creds cr;
	krb5_get_init_creds_opt opt;
	char *service;

#line 776 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	};

	if (ST(1) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	};

	if (ST(2) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(2), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};

	if (ST(3) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 427 "Krb5.xs"
	memset(&cr,0,sizeof(krb5_creds));
	krb5_get_init_creds_opt_init(&opt);
	err = krb5_unparse_name(context, server, &service);
	if (err) XSRETURN_UNDEF;

	err = krb5_get_init_creds_keytab(context, &cr, client, keytab, 0,
		service, &opt);
	free(service);
	if (err) XSRETURN_UNDEF;

	err = krb5_cc_initialize(context, cc, client);
	if (err) {
		krb5_free_cred_contents(context, &cr);
		XSRETURN_UNDEF;
	}
	err = krb5_cc_store_cred(context, cc, &cr);
	if (err) {
		krb5_free_cred_contents(context, &cr);
		XSRETURN_UNDEF;
	}
	krb5_free_cred_contents(context, &cr);

	XSRETURN_YES;
#line 845 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5_mk_req); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_mk_req)
{
    dXSARGS;
    if (items != 6)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::mk_req(auth_context, ap_req_options, service, hostname, in, cc)");
    {
	Authen__Krb5__AuthContext	auth_context;
	krb5_flags	ap_req_options = (int)SvIV(ST(1));
	char *	service = (char *)SvPV_nolen(ST(2));
	char *	hostname = (char *)SvPV_nolen(ST(3));
	SV *	in = ST(4);
	Authen__Krb5__Ccache	cc;
#line 461 "Krb5.xs"
	krb5_data in_data, out_data;

#line 867 "Krb5.c"
	SV *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};

	if (ST(5) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(5), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(5)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 464 "Krb5.xs"
	in_data.data = SvPV(in,in_data.length);
	err = krb5_mk_req(context,&auth_context,ap_req_options,service,hostname,
		&in_data,cc,&out_data);
	if (err) XSRETURN_UNDEF;
	RETVAL = newSVpv(out_data.data,out_data.length);

#line 898 "Krb5.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_rd_req); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_rd_req)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::rd_req(auth_context, in, server, keytab=0)");
    {
	Authen__Krb5__AuthContext	auth_context;
	SV *	in = ST(1);
	Authen__Krb5__Principal	server;
	Authen__Krb5__Keytab	keytab;
#line 481 "Krb5.xs"
	krb5_data in_data;
	krb5_ticket *t;
	krb5_flags ap_req_options;

#line 922 "Krb5.c"
	Authen__Krb5__Ticket	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};

	if (ST(2) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(2), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	};

	if (items < 4)
	    keytab = 0;
	else {
	    if (ST(3) == &PL_sv_undef) {
		    keytab = 0;
	    }
	    else if (sv_isa(ST(3), "Authen::Krb5::Keytab")) {
		    IV tmp = SvIV((SV*)SvRV(ST(3)));
		    keytab = (Authen__Krb5__Keytab) tmp;
	    }
	    else {
		    croak("keytab is not of type Authen::Krb5::Keytab");
	    };
	}
#line 486 "Krb5.xs"
	if (!New(0,t,1,krb5_ticket)) XSRETURN_UNDEF;
	in_data.data = SvPV(in,in_data.length);
	err = krb5_rd_req(context,&auth_context,&in_data,server,keytab,
		NULL,&t);
	if (err) XSRETURN_UNDEF;
	RETVAL = t;

	can_free((SV *)RETVAL);

#line 971 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Ticket", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_gen_portaddr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_gen_portaddr)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::gen_portaddr(addr, port)");
    {
	Authen__Krb5__Address	addr;
	unsigned short	port = (unsigned short)SvUV(ST(1));
	Authen__Krb5__Address	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		addr = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		addr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("addr is not of type Authen::Krb5::Address");
	};
#line 504 "Krb5.xs"
	err = krb5_gen_portaddr(context,addr,(krb5_pointer)&port,&RETVAL);
	if (err) XSRETURN_UNDEF;

#line 1004 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Address", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_genaddrs); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_genaddrs)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::genaddrs(auth_context, fh, flags)");
    {
	Authen__Krb5__AuthContext	auth_context;
	FILE *	fh = PerlIO_findFILE(IoIFP(sv_2io(ST(1))));
	krb5_flags	flags = (int)SvIV(ST(2));
#line 517 "Krb5.xs"
	int fd;

#line 1025 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 520 "Krb5.xs"
	fd = fileno(fh);
	err = krb5_auth_con_genaddrs(context,auth_context,fd,flags);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;  
#line 1042 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5_gen_replay_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_gen_replay_name)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::gen_replay_name(addr, uniq)");
    {
	Authen__Krb5__Address	addr;
	char *	uniq = (char *)SvPV_nolen(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		addr = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		addr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("addr is not of type Authen::Krb5::Address");
	};
#line 531 "Krb5.xs"
	err = krb5_gen_replay_name(context,addr,uniq,&RETVAL);
	if (err) XSRETURN_UNDEF;

#line 1074 "Krb5.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_mk_priv); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_mk_priv)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::mk_priv(auth_context, in)");
    SP -= items;
    {
	Authen__Krb5__AuthContext	auth_context;
	SV *	in = ST(1);
#line 543 "Krb5.xs"
	krb5_data in_data, out_data;

#line 1094 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 546 "Krb5.xs"
	in_data.data = SvPV(in,in_data.length);
	err = krb5_mk_priv(context,auth_context,&in_data,&out_data,NULL);
	if (err) XSRETURN_UNDEF;
	XPUSHs(sv_2mortal(newSVpv(out_data.data,out_data.length)));
	/* krb5_free_data(context,&out_data); */
#line 1112 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5_rd_priv); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_rd_priv)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::rd_priv(auth_context, in)");
    SP -= items;
    {
	Authen__Krb5__AuthContext	auth_context;
	SV *	in = ST(1);
#line 558 "Krb5.xs"
	krb5_data in_data, out_data;

#line 1132 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 561 "Krb5.xs"
	in_data.data = SvPV(in,in_data.length);
	err = krb5_rd_priv(context,auth_context,&in_data,&out_data,NULL);
	if (err) XSRETURN_UNDEF;
	XPUSHs(sv_2mortal(newSVpv(out_data.data,out_data.length)));
#line 1149 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5_get_server_rcache); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_get_server_rcache)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::get_server_rcache(piece)");
    {
	SV *	piece = ST(0);
#line 571 "Krb5.xs"
	krb5_data rc_data;

#line 1167 "Krb5.c"
	Authen__Krb5__Rcache	RETVAL;
#line 574 "Krb5.xs"
	rc_data.data=SvPV(piece,rc_data.length);
	err = krb5_get_server_rcache(context,&rc_data,&RETVAL);

	if (err) XSRETURN_UNDEF;

#line 1175 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Rcache", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5_sendauth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_sendauth)
{
    dXSARGS;
    if (items != 9)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::sendauth(auth_context, fh, version, client, server, options, in, in_creds, cc)");
    SP -= items;
    {
	Authen__Krb5__AuthContext	auth_context;
	FILE *	fh = PerlIO_findFILE(IoIFP(sv_2io(ST(1))));
	char *	version = (char *)SvPV_nolen(ST(2));
	Authen__Krb5__Principal	client;
	Authen__Krb5__Principal	server;
	int	options = (int)SvIV(ST(5));
	SV *	in = ST(6);
	Authen__Krb5__Creds	in_creds;
	Authen__Krb5__Ccache	cc;
#line 595 "Krb5.xs"
	krb5_data in_data;
	krb5_creds *out_creds = NULL;
	int fd;

#line 1205 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};

	if (ST(3) == &PL_sv_undef) {
		client = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		client = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("client is not of type Authen::Krb5::Principal");
	};

	if (ST(4) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(4), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(4)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	};

	if (ST(7) == &PL_sv_undef) {
		in_creds = 0;
	}
	else if (sv_isa(ST(7), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(7)));
		in_creds = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("in_creds is not of type Authen::Krb5::Creds");
	};

	if (ST(8) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(8), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(8)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 600 "Krb5.xs"
	fd = fileno(fh);
	in_data.data = SvPV(in,in_data.length);
	err = krb5_sendauth(context,&auth_context,&fd,version,client,server,
		options,&in_data,in_creds,cc,NULL,NULL,&out_creds);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 1268 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5_recvauth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5_recvauth)
{
    dXSARGS;
    if (items != 5)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::recvauth(auth_context, fh, version, server, keytab)");
    SP -= items;
    {
	Authen__Krb5__AuthContext	auth_context;
	FILE *	fh = PerlIO_findFILE(IoIFP(sv_2io(ST(1))));
	char *	version = (char *)SvPV_nolen(ST(2));
	Authen__Krb5__Principal	server;
	Authen__Krb5__Keytab	keytab;
#line 616 "Krb5.xs"
	krb5_ticket *ticket = NULL;
	int fd;

#line 1292 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};

	if (ST(3) == &PL_sv_undef) {
		server = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		server = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("server is not of type Authen::Krb5::Principal");
	};

	if (ST(4) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(4), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(4)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};
#line 620 "Krb5.xs"
	fd = fileno(fh);
	err = krb5_recvauth(context,&auth_context,&fd,version,server,0,
		keytab,&ticket);
	if (err) XSRETURN_UNDEF;
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0),"Authen::Krb5::Ticket",(void*)ticket);
	XSRETURN(1);
#line 1334 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5__Principal_realm); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Principal_realm)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Principal::realm(p)");
    {
	Authen__Krb5__Principal	p;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	};
#line 636 "Krb5.xs"
	ST(0) = sv_2mortal(newSVpv(p->realm.data,p->realm.length));
#line 1362 "Krb5.c"
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Principal_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Principal_type)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Principal::type(p)");
    {
	Authen__Krb5__Principal	p;
	krb5_int32	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	};
#line 643 "Krb5.xs"
	RETVAL = p->type;

#line 1392 "Krb5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Principal_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Principal_data)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Principal::data(p)");
    SP -= items;
    {
	Authen__Krb5__Principal	p;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	};
#line 653 "Krb5.xs"
	if (p->length > 0) {
		int len = p->length;
		krb5_data *data;

		EXTEND(sp,len);
		for (data = p->data; len--; data++) {
			PUSHs(sv_2mortal(newSVpv(data->data,data->length)));
		}
	}
#line 1429 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5__Principal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Principal_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Principal::DESTROY(p)");
    {
	Authen__Krb5__Principal	p;

	if (ST(0) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	};
#line 668 "Krb5.xs"
	if (p && should_free((SV *)p)) {
		krb5_free_principal(context,p);
		freed((SV *)p);
	}
#line 1460 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Ccache_initialize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_initialize)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::initialize(cc, p)");
    {
	Authen__Krb5__Ccache	cc;
	Authen__Krb5__Principal	p;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};

	if (ST(1) == &PL_sv_undef) {
		p = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		p = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("p is not of type Authen::Krb5::Principal");
	};
#line 682 "Krb5.xs"
	err = krb5_cc_initialize(context, cc, p);
	if (err) XSRETURN_UNDEF;
	else {
		can_free((SV *)cc);
		XSRETURN_YES;
	}
#line 1504 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Ccache_store_cred); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_store_cred)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::store_cred(cc, creds)");
    {
	Authen__Krb5__Ccache	cc;
	Authen__Krb5__Creds	creds;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};

	if (ST(1) == &PL_sv_undef) {
		creds = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		creds = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("creds is not of type Authen::Krb5::Creds");
	};
#line 695 "Krb5.xs"
	err = krb5_cc_store_cred(context, cc, creds);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 1545 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Ccache_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_get_name)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::get_name(cc)");
    {
	Authen__Krb5__Ccache	cc;
	const char *	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 704 "Krb5.xs"
	RETVAL = krb5_cc_get_name(context, cc);

#line 1575 "Krb5.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Ccache_get_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_get_principal)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::get_principal(cc)");
    {
	Authen__Krb5__Ccache	cc;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 714 "Krb5.xs"
	err = krb5_cc_get_principal(context, cc, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 1608 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Principal", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Ccache_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_destroy)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::destroy(cc)");
    {
	Authen__Krb5__Ccache	cc;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 727 "Krb5.xs"
	if (!should_free((SV*)cc)) XSRETURN_UNDEF;

	err = krb5_cc_destroy(context, cc);
	if (err) {
		XSRETURN_UNDEF;
	}
	else {
		freed((SV*)cc);
		XSRETURN_YES;
	}
#line 1646 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Ccache_start_seq_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_start_seq_get)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::start_seq_get(cc)");
    {
	Authen__Krb5__Ccache	cc;
	krb5_cc_cursor *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 743 "Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_cc_cursor))
		XSRETURN_UNDEF;
        err = krb5_cc_start_seq_get(context, cc, RETVAL);
	if (err)
                XSRETURN_UNDEF;

#line 1679 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "krb5_cc_cursorPtr", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Ccache_next_cred); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_next_cred)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::next_cred(cc, cursor)");
    {
	krb5_cc_cursor *	cursor;
	Authen__Krb5__Ccache	cc;
	Authen__Krb5__Creds	RETVAL;

	if (ST(1) == &PL_sv_undef) {
		cursor = 0;
	}
	else if (sv_isa(ST(1), "krb5_cc_cursorPtr")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		cursor = (krb5_cc_cursor *) tmp;
	}
	else {
		croak("cursor is not of type krb5_cc_cursorPtr");
	};

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 758 "Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_creds))
		XSRETURN_UNDEF;
        err = krb5_cc_next_cred(context, cc, cursor, RETVAL);
	if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 1727 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Creds", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Ccache_end_seq_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_end_seq_get)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::end_seq_get(cc, cursor)");
    {
	Authen__Krb5__Ccache	cc;
	krb5_cc_cursor *	cursor;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};

	if (ST(1) == &PL_sv_undef) {
		cursor = 0;
	}
	else if (sv_isa(ST(1), "krb5_cc_cursorPtr")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		cursor = (krb5_cc_cursor *) tmp;
	}
	else {
		croak("cursor is not of type krb5_cc_cursorPtr");
	};
#line 774 "Krb5.xs"
        err = krb5_cc_end_seq_get(context, cc, cursor);
        if (err)
                XSRETURN_UNDEF;
        XSRETURN_YES;
#line 1771 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Ccache_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ccache_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ccache::DESTROY(cc)");
    {
	Authen__Krb5__Ccache	cc;

	if (ST(0) == &PL_sv_undef) {
		cc = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ccache")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		cc = (Authen__Krb5__Ccache) tmp;
	}
	else {
		croak("cc is not of type Authen::Krb5::Ccache");
	};
#line 784 "Krb5.xs"
	if (should_free((SV *)cc)) {
		krb5_cc_close(context, cc);
		freed((SV *)cc);
	}
#line 1801 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__KeyBlock_length); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeyBlock_length)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeyBlock::length(kb)");
    {
	Authen__Krb5__KeyBlock	kb;
	int	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	};
#line 796 "Krb5.xs"
	RETVAL = kb->length;

#line 1831 "Krb5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__KeyBlock_contents); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeyBlock_contents)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeyBlock::contents(kb)");
    SP -= items;
    {
	Authen__Krb5__KeyBlock	kb;

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	};
#line 806 "Krb5.xs"
	/* sv_2mortal here causes 'Attempt to free unreferenced scalar' later */
	XPUSHs(newSVpvn((char*)(kb->contents), kb->length));
#line 1861 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5__KeyBlock_enctype); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeyBlock_enctype)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeyBlock::enctype(kb)");
    {
	Authen__Krb5__KeyBlock	kb;
	int	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	};
#line 814 "Krb5.xs"
	RETVAL = (int)kb->enctype;

#line 1892 "Krb5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__KeyBlock_enctype_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeyBlock_enctype_string)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeyBlock::enctype_string(kb)");
    SP -= items;
    {
	Authen__Krb5__KeyBlock	kb;
#line 824 "Krb5.xs"
	char buf[256];

#line 1911 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	};
#line 827 "Krb5.xs"
	err = krb5_enctype_to_string(kb->enctype, buf, 255);
	if (err) {
		XSRETURN_UNDEF;
	}
	XPUSHs(newSVpv(buf, 0));
#line 1929 "Krb5.c"
	PUTBACK;
	return;
    }
}


XS(XS_Authen__Krb5__KeyBlock_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeyBlock_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeyBlock::DESTROY(kb)");
    {
	Authen__Krb5__KeyBlock	kb;

	if (ST(0) == &PL_sv_undef) {
		kb = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeyBlock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		kb = (Authen__Krb5__KeyBlock) tmp;
	}
	else {
		croak("kb is not of type Authen::Krb5::KeyBlock");
	};
#line 838 "Krb5.xs"
	if (kb && should_free((SV *)kb)) {
		krb5_free_keyblock(context,kb);
		freed((SV *)kb);
	}
#line 1960 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__AuthContext_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_new)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::new(class)");
    {
	char *	class = (char *)SvPV_nolen(ST(0));
	Authen__Krb5__AuthContext	RETVAL;
#line 850 "Krb5.xs"
	err = krb5_auth_con_init(context, &RETVAL);
	if (err) XSRETURN_UNDEF;

	can_free((SV *)RETVAL);

#line 1981 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::AuthContext", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__AuthContext_getflags); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_getflags)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::getflags(auth_context)");
    {
	Authen__Krb5__AuthContext	auth_context;
#line 863 "Krb5.xs"
	krb5_int32 flags;

#line 2000 "Krb5.c"
	int	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 866 "Krb5.xs"
	err = krb5_auth_con_getflags(context,auth_context,&flags);
	RETVAL = (int)flags;

#line 2018 "Krb5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__AuthContext_setflags); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_setflags)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::setflags(auth_context, flags)");
    {
	Authen__Krb5__AuthContext	auth_context;
	krb5_int32	flags = (int)SvIV(ST(1));

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 878 "Krb5.xs"
	err = krb5_auth_con_setflags(context,auth_context,flags);

	if(err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2050 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__AuthContext_getrcache); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_getrcache)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::getrcache(auth_context)");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__Rcache	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 888 "Krb5.xs"
	err = krb5_auth_con_getrcache(context,auth_context,&RETVAL);
	if (err) XSRETURN_UNDEF;

#line 2080 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Rcache", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__AuthContext_setrcache); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_setrcache)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::setrcache(auth_context, rc)");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__Rcache	rc;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};

	if (ST(1) == &PL_sv_undef) {
		rc = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Rcache")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		rc = (Authen__Krb5__Rcache) tmp;
	}
	else {
		croak("rc is not of type Authen::Krb5::Rcache");
	};
#line 900 "Krb5.xs"
	err = krb5_auth_con_setrcache(context,auth_context,rc);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2123 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__AuthContext_getaddrs); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_getaddrs)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::getaddrs(auth_context)");
    {
	Authen__Krb5__AuthContext	auth_context;
#line 909 "Krb5.xs"
	krb5_address *local, *remote;

#line 2140 "Krb5.c"

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 912 "Krb5.xs"
	err = krb5_auth_con_getaddrs(context,auth_context,&local,&remote);
	if (err) XSRETURN_EMPTY;

	ST(0) = sv_newmortal();
	ST(1) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Address", (void*)local);
	sv_setref_pv(ST(1), "Authen::Krb5::Address", (void*)remote);
	XSRETURN(2);
#line 2161 "Krb5.c"
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__AuthContext_setaddrs); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_setaddrs)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::setaddrs(auth_context, laddr, raddr)");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__Address	laddr;
	Authen__Krb5__Address	raddr;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};

	if (ST(1) == &PL_sv_undef) {
		laddr = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		laddr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("laddr is not of type Authen::Krb5::Address");
	};

	if (ST(2) == &PL_sv_undef) {
		raddr = 0;
	}
	else if (sv_isa(ST(2), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		raddr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("raddr is not of type Authen::Krb5::Address");
	};
#line 928 "Krb5.xs"
	if (!SvOK((SV*)ST(1))) laddr = NULL;
	if (!SvOK((SV*)ST(2))) raddr = NULL;
	err = krb5_auth_con_setaddrs(context,auth_context,laddr,raddr);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2216 "Krb5.c"
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__AuthContext_setports); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_setports)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::setports(auth_context, laddr, raddr)");
    {
	Authen__Krb5__AuthContext	auth_context;
	Authen__Krb5__Address	laddr;
	Authen__Krb5__Address	raddr;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};

	if (ST(1) == &PL_sv_undef) {
		laddr = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		laddr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("laddr is not of type Authen::Krb5::Address");
	};

	if (ST(2) == &PL_sv_undef) {
		raddr = 0;
	}
	else if (sv_isa(ST(2), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		raddr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("raddr is not of type Authen::Krb5::Address");
	};
#line 941 "Krb5.xs"
	if (!SvOK((SV*)ST(1))) laddr = NULL;
	if (!SvOK((SV*)ST(2))) raddr = NULL;
	err = krb5_auth_con_setports(context,auth_context,laddr,raddr);
	if (err) XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2271 "Krb5.c"
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__AuthContext_getkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_getkey)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::getkey(auth_context)");
    {
	Authen__Krb5__AuthContext	auth_context;
#line 952 "Krb5.xs"
	SV *sv;

#line 2288 "Krb5.c"
	Authen__Krb5__KeyBlock	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 955 "Krb5.xs"
	err = krb5_auth_con_getkey(context, auth_context, &RETVAL);
	if (err) XSRETURN_UNDEF;
	can_free((SV *)RETVAL);

#line 2306 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::KeyBlock", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__AuthContext_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__AuthContext_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::AuthContext::DESTROY(auth_context)");
    {
	Authen__Krb5__AuthContext	auth_context;

	if (ST(0) == &PL_sv_undef) {
		auth_context = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::AuthContext")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		auth_context = (Authen__Krb5__AuthContext) tmp;
	}
	else {
		croak("auth_context is not of type Authen::Krb5::AuthContext");
	};
#line 967 "Krb5.xs"
	if (auth_context) {
		krb5_auth_con_free(context, auth_context);
		freed((SV *)auth_context);
	}
#line 2338 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Ticket_server); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ticket_server)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ticket::server(t)");
    {
	Authen__Krb5__Ticket	t;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		t = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ticket")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		t = (Authen__Krb5__Ticket) tmp;
	}
	else {
		croak("t is not of type Authen::Krb5::Ticket");
	};
#line 979 "Krb5.xs"
	RETVAL = t->server;

#line 2367 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Principal", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Ticket_enc_part2); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ticket_enc_part2)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ticket::enc_part2(t)");
    {
	Authen__Krb5__Ticket	t;
	Authen__Krb5__EncTktPart	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		t = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ticket")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		t = (Authen__Krb5__Ticket) tmp;
	}
	else {
		croak("t is not of type Authen::Krb5::Ticket");
	};
#line 989 "Krb5.xs"
	RETVAL = t->enc_part2;

#line 2398 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::EncTktPart", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Ticket_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Ticket_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Ticket::DESTROY(t)");
    {
	Authen__Krb5__Ticket	t;

	if (ST(0) == &PL_sv_undef) {
		t = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Ticket")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		t = (Authen__Krb5__Ticket) tmp;
	}
	else {
		croak("t is not of type Authen::Krb5::Ticket");
	};
#line 999 "Krb5.xs"
	if (t) {
		krb5_free_ticket(context,t);
		freed((SV *)t);
	}
#line 2430 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__EncTktPart_client); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__EncTktPart_client)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::EncTktPart::client(etp)");
    {
	Authen__Krb5__EncTktPart	etp;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		etp = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::EncTktPart")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		etp = (Authen__Krb5__EncTktPart) tmp;
	}
	else {
		croak("etp is not of type Authen::Krb5::EncTktPart");
	};
#line 1011 "Krb5.xs"
	RETVAL = etp->client;

#line 2459 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Principal", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__EncTktPart_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__EncTktPart_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::EncTktPart::DESTROY(etp)");
    {
	Authen__Krb5__EncTktPart	etp;

	if (ST(0) == &PL_sv_undef) {
		etp = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::EncTktPart")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		etp = (Authen__Krb5__EncTktPart) tmp;
	}
	else {
		croak("etp is not of type Authen::Krb5::EncTktPart");
	};
#line 1021 "Krb5.xs"
	if (etp && should_free((SV *)etp)) {
		krb5_free_enc_tkt_part(context,etp);
		freed((SV *)etp);
	}
#line 2491 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Address_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Address_new)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Address::new(class, addrtype, contents)");
    {
	char *	class = (char *)SvPV_nolen(ST(0));
	unsigned int	addrtype = (unsigned int)SvUV(ST(1));
	SV *	contents = ST(2);
	Authen__Krb5__Address	RETVAL;
#line 1035 "Krb5.xs"
	if (!New(0,RETVAL,1,krb5_address)) XSRETURN_UNDEF;
	RETVAL->addrtype = addrtype;
	RETVAL->contents = (krb5_octet *)SvPV(contents,RETVAL->length);

#line 2513 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Address", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Address_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Address_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Address::DESTROY(addr)");
    {
	Authen__Krb5__Address	addr;

	if (ST(0) == &PL_sv_undef) {
		addr = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Address")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		addr = (Authen__Krb5__Address) tmp;
	}
	else {
		croak("addr is not of type Authen::Krb5::Address");
	};
#line 1047 "Krb5.xs"
	if (addr && should_free((SV *)addr)) {
		krb5_free_address(context,addr);
		freed((SV *)addr);
	}
#line 2545 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Keyblock_enctype); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keyblock_enctype)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keyblock::enctype(keyblock)");
    {
	Authen__Krb5__Keyblock	keyblock;
	krb5_enctype	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		keyblock = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keyblock = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("keyblock is not of type Authen::Krb5::Keyblock");
	};
#line 1060 "Krb5.xs"
        RETVAL = keyblock->enctype;

#line 2575 "Krb5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Keyblock_length); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keyblock_length)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keyblock::length(keyblock)");
    {
	Authen__Krb5__Keyblock	keyblock;
	unsigned int	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		keyblock = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keyblock = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("keyblock is not of type Authen::Krb5::Keyblock");
	};
#line 1070 "Krb5.xs"
        RETVAL = keyblock->length;

#line 2606 "Krb5.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Keyblock_contents); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keyblock_contents)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keyblock::contents(keyblock)");
    {
	Authen__Krb5__Keyblock	keyblock;
	krb5_octet *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		keyblock = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keyblock = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("keyblock is not of type Authen::Krb5::Keyblock");
	};
#line 1080 "Krb5.xs"
        ST(0) = keyblock->contents
	    ? sv_2mortal(newSVpv(keyblock->contents, keyblock->length))
            : &PL_sv_undef;
#line 2637 "Krb5.c"
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Keyblock_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keyblock_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keyblock::DESTROY(keyblock)");
    {
	Authen__Krb5__Keyblock	keyblock;

	if (ST(0) == &PL_sv_undef) {
		keyblock = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keyblock = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("keyblock is not of type Authen::Krb5::Keyblock");
	};
#line 1090 "Krb5.xs"
	if (keyblock->contents) {
		memset(keyblock->contents, 0, keyblock->length);
		free(keyblock->contents);
		keyblock->contents = NULL;
	}
#line 2668 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Keytab_add_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keytab_add_entry)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keytab::add_entry(keytab, entry)");
    {
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__KeytabEntry	entry;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};

	if (ST(1) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	};
#line 1104 "Krb5.xs"
        err = krb5_kt_add_entry(context, keytab, entry);
	if (err)
                XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2710 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Keytab_end_seq_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keytab_end_seq_get)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keytab::end_seq_get(keytab, cursor)");
    {
	Authen__Krb5__Keytab	keytab;
	krb5_kt_cursor *	cursor;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};

	if (ST(1) == &PL_sv_undef) {
		cursor = 0;
	}
	else if (sv_isa(ST(1), "krb5_kt_cursorPtr")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		cursor = (krb5_kt_cursor *) tmp;
	}
	else {
		croak("cursor is not of type krb5_kt_cursorPtr");
	};
#line 1115 "Krb5.xs"
        err = krb5_kt_end_seq_get(context, keytab, cursor);
        if (err)
                XSRETURN_UNDEF;
        XSRETURN_YES;
#line 2752 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Keytab_get_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keytab_get_entry)
{
    dXSARGS;
    if (items < 2 || items > 4)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keytab::get_entry(keytab, principal, vno = 0, enctype = 0)");
    {
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__Principal	principal;
	krb5_kvno	vno;
	krb5_enctype	enctype;
	Authen__Krb5__KeytabEntry	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};

	if (ST(1) == &PL_sv_undef) {
		principal = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		principal = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("principal is not of type Authen::Krb5::Principal");
	};

	if (items < 3)
	    vno = 0;
	else {
	    vno = (unsigned int)SvUV(ST(2));
	}

	if (items < 4)
	    enctype = 0;
	else {
	    enctype = (int)SvIV(ST(3));
	}
#line 1128 "Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_keytab_entry))
		XSRETURN_UNDEF;
        err = krb5_kt_get_entry(context, keytab, principal, vno, enctype,
            RETVAL);
	if (err)
		XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 2813 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::KeytabEntry", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Keytab_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keytab_get_name)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keytab::get_name(keytab)");
    {
	Authen__Krb5__Keytab	keytab;
#line 1144 "Krb5.xs"
        char name[MAX_KEYTAB_NAME_LEN+1];

#line 2832 "Krb5.c"
	SV *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};
#line 1147 "Krb5.xs"
        err = krb5_kt_get_name(context, keytab, name, MAX_KEYTAB_NAME_LEN);
	if (err)
                XSRETURN_UNDEF;
	RETVAL = sv_2mortal(newSVpv(name, 0));
        can_free((SV *)RETVAL);

#line 2852 "Krb5.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Keytab_next_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keytab_next_entry)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keytab::next_entry(keytab, cursor)");
    {
	krb5_kt_cursor *	cursor;
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__KeytabEntry	RETVAL;

	if (ST(1) == &PL_sv_undef) {
		cursor = 0;
	}
	else if (sv_isa(ST(1), "krb5_kt_cursorPtr")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		cursor = (krb5_kt_cursor *) tmp;
	}
	else {
		croak("cursor is not of type krb5_kt_cursorPtr");
	};

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};
#line 1162 "Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_keytab_entry))
		XSRETURN_UNDEF;
        err = krb5_kt_next_entry(context, keytab, RETVAL, cursor);
	if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 2900 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::KeytabEntry", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Keytab_remove_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keytab_remove_entry)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keytab::remove_entry(keytab, entry)");
    {
	Authen__Krb5__Keytab	keytab;
	Authen__Krb5__KeytabEntry	entry;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};

	if (ST(1) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	};
#line 1178 "Krb5.xs"
        err = krb5_kt_remove_entry(context, keytab, entry);
	if (err)
                XSRETURN_UNDEF;
	XSRETURN_YES;
#line 2944 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__Keytab_start_seq_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keytab_start_seq_get)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keytab::start_seq_get(keytab)");
    {
	Authen__Krb5__Keytab	keytab;
	krb5_kt_cursor *	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};
#line 1188 "Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_kt_cursor))
		XSRETURN_UNDEF;
        err = krb5_kt_start_seq_get(context, keytab, RETVAL);
	if (err)
                XSRETURN_UNDEF;

#line 2977 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "krb5_kt_cursorPtr", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Keytab_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Keytab_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Keytab::DESTROY(keytab)");
    {
	Authen__Krb5__Keytab	keytab;

	if (ST(0) == &PL_sv_undef) {
		keytab = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Keytab")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		keytab = (Authen__Krb5__Keytab) tmp;
	}
	else {
		croak("keytab is not of type Authen::Krb5::Keytab");
	};
#line 1202 "Krb5.xs"
        if (keytab && should_free((SV *)keytab)) {
                krb5_kt_close(context, keytab);
                freed((SV *)keytab);
        }
#line 3009 "Krb5.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Authen__Krb5__KeytabEntry_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeytabEntry_new)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeytabEntry::new(class, principal, vno, key)");
    {
	char *	class = (char *)SvPV_nolen(ST(0));
	Authen__Krb5__Principal	principal;
	krb5_kvno	vno = (unsigned int)SvUV(ST(2));
	Authen__Krb5__Keyblock	key;
	Authen__Krb5__KeytabEntry	RETVAL;

	if (ST(1) == &PL_sv_undef) {
		principal = 0;
	}
	else if (sv_isa(ST(1), "Authen::Krb5::Principal")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		principal = (Authen__Krb5__Principal) tmp;
	}
	else {
		croak("principal is not of type Authen::Krb5::Principal");
	};

	if (ST(3) == &PL_sv_undef) {
		key = 0;
	}
	else if (sv_isa(ST(3), "Authen::Krb5::Keyblock")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		key = (Authen__Krb5__Keyblock) tmp;
	}
	else {
		croak("key is not of type Authen::Krb5::Keyblock");
	};
#line 1217 "Krb5.xs"
	if (!New(0, RETVAL, 1, krb5_keytab_entry))
		XSRETURN_UNDEF;
        *RETVAL = keytab_entry_init;
	RETVAL->principal = principal;
	RETVAL->vno = vno;
        RETVAL->key = *key;

        can_free((SV *)RETVAL);

#line 3059 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::KeytabEntry", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__KeytabEntry_principal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeytabEntry_principal)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeytabEntry::principal(entry)");
    {
	Authen__Krb5__KeytabEntry	entry;
	Authen__Krb5__Principal	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	};
#line 1234 "Krb5.xs"
        err = krb5_copy_principal(context, entry->principal, &RETVAL);
        if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 3093 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Principal", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__KeytabEntry_timestamp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeytabEntry_timestamp)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeytabEntry::timestamp(entry)");
    {
	Authen__Krb5__KeytabEntry	entry;
	krb5_timestamp	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	};
#line 1247 "Krb5.xs"
        RETVAL = entry->timestamp;

#line 3125 "Krb5.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__KeytabEntry_kvno); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeytabEntry_kvno)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeytabEntry::kvno(entry)");
    {
	Authen__Krb5__KeytabEntry	entry;
	krb5_kvno	RETVAL;
	dXSTARG;

	if (ST(0) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	};
#line 1257 "Krb5.xs"
        RETVAL = entry->vno;

#line 3156 "Krb5.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__KeytabEntry_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__KeytabEntry_key)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::KeytabEntry::key(entry)");
    {
	Authen__Krb5__KeytabEntry	entry;
	Authen__Krb5__Keyblock	RETVAL;

	if (ST(0) == &PL_sv_undef) {
		entry = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::KeytabEntry")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		entry = (Authen__Krb5__KeytabEntry) tmp;
	}
	else {
		croak("entry is not of type Authen::Krb5::KeytabEntry");
	};
#line 1267 "Krb5.xs"
        err = krb5_copy_keyblock(context, &entry->key, &RETVAL);
        if (err)
                XSRETURN_UNDEF;
        can_free((SV *)RETVAL);

#line 3189 "Krb5.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Authen::Krb5::Keyblock", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Authen__Krb5__Creds_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Authen__Krb5__Creds_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Authen::Krb5::Creds::DESTROY(creds)");
    {
	Authen__Krb5__Creds	creds;

	if (ST(0) == &PL_sv_undef) {
		creds = 0;
	}
	else if (sv_isa(ST(0), "Authen::Krb5::Creds")) {
		IV tmp = SvIV((SV*)SvRV(ST(0)));
		creds = (Authen__Krb5__Creds) tmp;
	}
	else {
		croak("creds is not of type Authen::Krb5::Creds");
	};
#line 1282 "Krb5.xs"
        if (creds && should_free((SV *)creds)) {
                krb5_free_cred_contents(context, creds);
                free(creds);
                freed((SV *)creds);
        }
#line 3222 "Krb5.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Authen__Krb5); /* prototype to pass -Wmissing-prototypes */
XS(boot_Authen__Krb5)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("Authen::Krb5::constant", XS_Authen__Krb5_constant, file);
        newXS("Authen::Krb5::error", XS_Authen__Krb5_error, file);
        newXS("Authen::Krb5::init_context", XS_Authen__Krb5_init_context, file);
        newXS("Authen::Krb5::free_context", XS_Authen__Krb5_free_context, file);
        newXS("Authen::Krb5::init_ets", XS_Authen__Krb5_init_ets, file);
        newXS("Authen::Krb5::get_default_realm", XS_Authen__Krb5_get_default_realm, file);
        newXS("Authen::Krb5::get_host_realm", XS_Authen__Krb5_get_host_realm, file);
        newXS("Authen::Krb5::get_krbhst", XS_Authen__Krb5_get_krbhst, file);
        newXS("Authen::Krb5::build_principal_ext", XS_Authen__Krb5_build_principal_ext, file);
        newXS("Authen::Krb5::parse_name", XS_Authen__Krb5_parse_name, file);
        newXS("Authen::Krb5::sname_to_principal", XS_Authen__Krb5_sname_to_principal, file);
        newXS("Authen::Krb5::cc_resolve", XS_Authen__Krb5_cc_resolve, file);
        newXS("Authen::Krb5::cc_default_name", XS_Authen__Krb5_cc_default_name, file);
        newXS("Authen::Krb5::cc_default", XS_Authen__Krb5_cc_default, file);
        newXS("Authen::Krb5::kt_resolve", XS_Authen__Krb5_kt_resolve, file);
        newXS("Authen::Krb5::kt_default_name", XS_Authen__Krb5_kt_default_name, file);
        newXS("Authen::Krb5::kt_default", XS_Authen__Krb5_kt_default, file);
        newXS("Authen::Krb5::kt_read_service_key", XS_Authen__Krb5_kt_read_service_key, file);
        newXS("Authen::Krb5::get_init_creds_password", XS_Authen__Krb5_get_init_creds_password, file);
        newXS("Authen::Krb5::get_init_creds_keytab", XS_Authen__Krb5_get_init_creds_keytab, file);
        newXS("Authen::Krb5::get_in_tkt_with_password", XS_Authen__Krb5_get_in_tkt_with_password, file);
        newXS("Authen::Krb5::get_in_tkt_with_keytab", XS_Authen__Krb5_get_in_tkt_with_keytab, file);
        newXS("Authen::Krb5::mk_req", XS_Authen__Krb5_mk_req, file);
        newXS("Authen::Krb5::rd_req", XS_Authen__Krb5_rd_req, file);
        newXS("Authen::Krb5::gen_portaddr", XS_Authen__Krb5_gen_portaddr, file);
        newXS("Authen::Krb5::genaddrs", XS_Authen__Krb5_genaddrs, file);
        newXS("Authen::Krb5::gen_replay_name", XS_Authen__Krb5_gen_replay_name, file);
        newXS("Authen::Krb5::mk_priv", XS_Authen__Krb5_mk_priv, file);
        newXS("Authen::Krb5::rd_priv", XS_Authen__Krb5_rd_priv, file);
        newXS("Authen::Krb5::get_server_rcache", XS_Authen__Krb5_get_server_rcache, file);
        newXS("Authen::Krb5::sendauth", XS_Authen__Krb5_sendauth, file);
        newXS("Authen::Krb5::recvauth", XS_Authen__Krb5_recvauth, file);
        newXS("Authen::Krb5::Principal::realm", XS_Authen__Krb5__Principal_realm, file);
        newXS("Authen::Krb5::Principal::type", XS_Authen__Krb5__Principal_type, file);
        newXS("Authen::Krb5::Principal::data", XS_Authen__Krb5__Principal_data, file);
        newXS("Authen::Krb5::Principal::DESTROY", XS_Authen__Krb5__Principal_DESTROY, file);
        newXS("Authen::Krb5::Ccache::initialize", XS_Authen__Krb5__Ccache_initialize, file);
        newXS("Authen::Krb5::Ccache::store_cred", XS_Authen__Krb5__Ccache_store_cred, file);
        newXS("Authen::Krb5::Ccache::get_name", XS_Authen__Krb5__Ccache_get_name, file);
        newXS("Authen::Krb5::Ccache::get_principal", XS_Authen__Krb5__Ccache_get_principal, file);
        newXS("Authen::Krb5::Ccache::destroy", XS_Authen__Krb5__Ccache_destroy, file);
        newXS("Authen::Krb5::Ccache::start_seq_get", XS_Authen__Krb5__Ccache_start_seq_get, file);
        newXS("Authen::Krb5::Ccache::next_cred", XS_Authen__Krb5__Ccache_next_cred, file);
        newXS("Authen::Krb5::Ccache::end_seq_get", XS_Authen__Krb5__Ccache_end_seq_get, file);
        newXS("Authen::Krb5::Ccache::DESTROY", XS_Authen__Krb5__Ccache_DESTROY, file);
        newXS("Authen::Krb5::KeyBlock::length", XS_Authen__Krb5__KeyBlock_length, file);
        newXS("Authen::Krb5::KeyBlock::contents", XS_Authen__Krb5__KeyBlock_contents, file);
        newXS("Authen::Krb5::KeyBlock::enctype", XS_Authen__Krb5__KeyBlock_enctype, file);
        newXS("Authen::Krb5::KeyBlock::enctype_string", XS_Authen__Krb5__KeyBlock_enctype_string, file);
        newXS("Authen::Krb5::KeyBlock::DESTROY", XS_Authen__Krb5__KeyBlock_DESTROY, file);
        newXS("Authen::Krb5::AuthContext::new", XS_Authen__Krb5__AuthContext_new, file);
        newXS("Authen::Krb5::AuthContext::getflags", XS_Authen__Krb5__AuthContext_getflags, file);
        newXS("Authen::Krb5::AuthContext::setflags", XS_Authen__Krb5__AuthContext_setflags, file);
        newXS("Authen::Krb5::AuthContext::getrcache", XS_Authen__Krb5__AuthContext_getrcache, file);
        newXS("Authen::Krb5::AuthContext::setrcache", XS_Authen__Krb5__AuthContext_setrcache, file);
        newXS("Authen::Krb5::AuthContext::getaddrs", XS_Authen__Krb5__AuthContext_getaddrs, file);
        newXS("Authen::Krb5::AuthContext::setaddrs", XS_Authen__Krb5__AuthContext_setaddrs, file);
        newXS("Authen::Krb5::AuthContext::setports", XS_Authen__Krb5__AuthContext_setports, file);
        newXS("Authen::Krb5::AuthContext::getkey", XS_Authen__Krb5__AuthContext_getkey, file);
        newXS("Authen::Krb5::AuthContext::DESTROY", XS_Authen__Krb5__AuthContext_DESTROY, file);
        newXS("Authen::Krb5::Ticket::server", XS_Authen__Krb5__Ticket_server, file);
        newXS("Authen::Krb5::Ticket::enc_part2", XS_Authen__Krb5__Ticket_enc_part2, file);
        newXS("Authen::Krb5::Ticket::DESTROY", XS_Authen__Krb5__Ticket_DESTROY, file);
        newXS("Authen::Krb5::EncTktPart::client", XS_Authen__Krb5__EncTktPart_client, file);
        newXS("Authen::Krb5::EncTktPart::DESTROY", XS_Authen__Krb5__EncTktPart_DESTROY, file);
        newXS("Authen::Krb5::Address::new", XS_Authen__Krb5__Address_new, file);
        newXS("Authen::Krb5::Address::DESTROY", XS_Authen__Krb5__Address_DESTROY, file);
        newXS("Authen::Krb5::Keyblock::enctype", XS_Authen__Krb5__Keyblock_enctype, file);
        newXS("Authen::Krb5::Keyblock::length", XS_Authen__Krb5__Keyblock_length, file);
        newXS("Authen::Krb5::Keyblock::contents", XS_Authen__Krb5__Keyblock_contents, file);
        newXS("Authen::Krb5::Keyblock::DESTROY", XS_Authen__Krb5__Keyblock_DESTROY, file);
        newXS("Authen::Krb5::Keytab::add_entry", XS_Authen__Krb5__Keytab_add_entry, file);
        newXS("Authen::Krb5::Keytab::end_seq_get", XS_Authen__Krb5__Keytab_end_seq_get, file);
        newXS("Authen::Krb5::Keytab::get_entry", XS_Authen__Krb5__Keytab_get_entry, file);
        newXS("Authen::Krb5::Keytab::get_name", XS_Authen__Krb5__Keytab_get_name, file);
        newXS("Authen::Krb5::Keytab::next_entry", XS_Authen__Krb5__Keytab_next_entry, file);
        newXS("Authen::Krb5::Keytab::remove_entry", XS_Authen__Krb5__Keytab_remove_entry, file);
        newXS("Authen::Krb5::Keytab::start_seq_get", XS_Authen__Krb5__Keytab_start_seq_get, file);
        newXS("Authen::Krb5::Keytab::DESTROY", XS_Authen__Krb5__Keytab_DESTROY, file);
        newXS("Authen::Krb5::KeytabEntry::new", XS_Authen__Krb5__KeytabEntry_new, file);
        newXS("Authen::Krb5::KeytabEntry::principal", XS_Authen__Krb5__KeytabEntry_principal, file);
        newXS("Authen::Krb5::KeytabEntry::timestamp", XS_Authen__Krb5__KeytabEntry_timestamp, file);
        newXS("Authen::Krb5::KeytabEntry::kvno", XS_Authen__Krb5__KeytabEntry_kvno, file);
        newXS("Authen::Krb5::KeytabEntry::key", XS_Authen__Krb5__KeytabEntry_key, file);
        newXS("Authen::Krb5::Creds::DESTROY", XS_Authen__Krb5__Creds_DESTROY, file);
    XSRETURN_YES;
}

